/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ValidarEdadBeneficiarioConDiscapacidad extends AbstractRule
{
    
    String DATE_FORMAT = "dd/MM/yyyy";
    SimpleDateFormat sdf;

    public ValidarEdadBeneficiarioConDiscapacidad() {
        sdf = new SimpleDateFormat(DATE_FORMAT);
        sdf.setLenient(false);
    }
    
    public void setParams(Object[] params)
    {
        super.setParams(params);
    }

    public boolean performValidation(String field, String registro[],String nombreArchivo) 
    {              
        String codigoNovedad = (String) getParams()[5];
        String siglaBeneficiario = (String) getParams()[6];
        String siglaDiscapacidad = (String) getParams()[7];  
        int edadMaxima = Integer.parseInt((String) getParams()[8]);
        String parentescoCabezaFamiliaPermitido = (String) getParams()[10];
               
        String codigoNovedadRegistro = registro[new Integer((String) getParams()[0]).intValue()];
        String siglaBeneficiarioRegistro = registro[new Integer((String) getParams()[1]).intValue()];
        String siglaDiscapacidadRegistro = registro[new Integer((String) getParams()[2]).intValue()];
        String fechaNacimientoAfiliado = registro[new Integer((String) getParams()[3]).intValue()];
        String fechaInicioNovedad = registro[new Integer((String) getParams()[4]).intValue()];
        String parentescoCabezaFamiliaRegistro = registro[Integer.parseInt((String) getParams()[9])];
               
        if (!ValidarFecha.esFecha(fechaNacimientoAfiliado) || !ValidarFecha.esFecha(fechaInicioNovedad))
        {
            return true;
        }			
        
        Date convertFechaNacimientoAfiliado;
        Date converFechaInicioNovedad;
        try 
        {
            convertFechaNacimientoAfiliado = sdf.parse(fechaNacimientoAfiliado);
            converFechaInicioNovedad = sdf.parse(fechaInicioNovedad);
        } 
        catch (Exception e) 
        {
            return true;
        }   

        double diferenciaEntreFechasEnAños = ((double)ObtenerDiasEntreFechas.calcular(convertFechaNacimientoAfiliado, converFechaInicioNovedad))/365;

        if (codigoNovedad.equals(codigoNovedadRegistro) && siglaBeneficiario.equals(siglaBeneficiarioRegistro)) 
        {                                               
                if (parentescoCabezaFamiliaPermitido.equals(parentescoCabezaFamiliaRegistro))
                {
                    if (diferenciaEntreFechasEnAños >= edadMaxima) //27>25 -->true
                    {
                        if(!siglaDiscapacidad.equals(siglaDiscapacidadRegistro))
                        { 
                            return true;
                        }
                    }
                }                                              
        }
        return false;                                
    }
}

